/* $Id: result.c,v 1.12 2002/07/13 17:27:10 oohara Exp $ */

/* VERSION */
#include <config.h>

#include <stdio.h>
/* strlen */
#include <string.h>

#include "stage.h"
#include "score.h"
#include "tenm_graphic.h"
#include "util.h"
#include "tenm_input.h"
#include "tenm_timer.h"
#include "esc-ok.h"

#include "result.h"

/* return 1 if the program should quit, 0 if not */
int
show_result(void)
{
  int i;
  char temp[32];

  /* no need to detect focus loss */
  tenm_set_focus_handler((void (*)(int)) NULL);

  tenm_clear_window(tenm_map_color(253, 245, 230));

  if (draw_string(100, 90, "tenmado result", 14) != 0)
    fprintf(stderr, "show_result: draw_string (line 1) failed\n");

  snprintf(temp, 32, "version %s", VERSION);
  if (draw_string(100, 120, temp, strlen(temp)) != 0)
    fprintf(stderr, "show_result: draw_string (line 2) failed\n");

  snprintf(temp, 32, "total score: %8d", get_score());
  if (draw_string(100, 180, temp, strlen(temp)) != 0)
    fprintf(stderr, "show_result: draw_string (line 3) failed\n");

  for (i = 1; i <= 4; i++)
  {
    snprintf(temp, 32, "stage %1d:     %8d", i, get_stage_score(i));
    if (draw_string(100, 210 + i * 30, temp, strlen(temp)) != 0)
      fprintf(stderr, "show_result: draw_string (line %d) failed\n", i + 3);
  }

  snprintf(temp, 32, "final stage: %8d", get_stage_score(5));
  if (draw_string(100, 360, temp, strlen(temp)) != 0)
    fprintf(stderr, "show_result: draw_string (line 8) failed\n");

  if (get_stage() == 6)
  {
    /* the player cleared the entire game */
    snprintf(temp, 32, "ship bonus:  %8d", get_stage_score(6));
    if (draw_string(100, 390, temp, strlen(temp)) != 0)
      fprintf(stderr, "show_result: draw_string (line 9) failed\n");
  }

  if (draw_string(160, 600, "press ESC to quit", 17) != 0)
    fprintf(stderr, "show_result: draw_string (ESC instruction) failed\n");

  tenm_redraw_window();

  while (1 == 1)
  {
    /* quit the program if a SDL_QUIT event happened
     * (for example, if a SIGINT signal (sent by Ctrl+c) is received)
     */
    if (tenm_event_handle() != 0)
      return 1;

    /* back to the title if ESC is pressed */
    if (tenm_get_key_status() & 32)
    {
      if (get_esc_ok())
      {
        set_esc_ok(0);
        break;
      }
    }    
    else
    {
      set_esc_ok(1);
    }
    
    /* this wait is necessary to save CPU time */
    tenm_wait_next_frame();
  }

  return 0;
}
