/* $Id: main.c,v 1.208 2002/07/13 07:51:31 oohara Exp $ */

#include <stdio.h>
/* rand, exit */
#include <stdlib.h>

#include "const.h"
#include "tenm_graphic.h"
#include "tenm_input.h"
#include "tenm_math.h"
#include "tenm_table.h"
#include "tenm_timer.h"
#include "util.h"
#include "image.h"
/* pause_by_mouse */
#include "pause.h"
#include "loop.h"
#include "title.h"

/* note that delay granularity is 10 ms */
#define NUM_WAIT 3

int
main(int argc, char *argv[])
{
  int choice;
  int temp;

  tenm_graphic_init(WINDOW_WIDTH, WINDOW_HEIGHT);
  tenm_clear_window(tenm_map_color(255, 239, 213));
  tenm_timer_init(NUM_WAIT);
  if (tenm_math_init(810, 11) != 0)
    fprintf(stderr, "main: tenm_math_init failed, continuing (can be slow)\n");
  util_init(WINDOW_WIDTH, WINDOW_HEIGHT);
  image_init();
  tenm_table_init(256, -1, 1);
  tenm_set_key(7, TENM_KEY_UP, TENM_KEY_DOWN, TENM_KEY_RIGHT, TENM_KEY_LEFT,
               TENM_KEY_SPACE, TENM_KEY_ESCAPE, TENM_KEY_p);


  temp = tenm_joystick_init(256);
  if (temp == TENM_JOYSTICK_INIT_ERROR)
  {
    fprintf(stderr, "main: tenm_joystick_init failed\n");
    return 1;
  }
  else if (temp == TENM_JOYSTICK_INIT_NO_JOYSTICK)
  {
    fprintf(stderr, "main: don't worry, just use the keyboard\n");
  }
  else
  {
    tenm_joystick_map_axis(TENM_JOYSTICK_UP, TENM_KEY_UP);
    tenm_joystick_map_axis(TENM_JOYSTICK_DOWN, TENM_KEY_DOWN);
    tenm_joystick_map_axis(TENM_JOYSTICK_LEFT, TENM_KEY_LEFT);
    tenm_joystick_map_axis(TENM_JOYSTICK_RIGHT, TENM_KEY_RIGHT);
    tenm_joystick_map_button(0, TENM_KEY_SPACE);
  }

  choice = title();
  while (choice != 2)
  {
    if (main_loop(choice) != 0)
      break;
    choice = title();
  }

  image_quit();
  return 0;
}
